%define qt3dir %_libdir/qt3
%define qt4dir %_libdir/qt4
#%define snapshot 20080103

Summary: QScintilla is a port to Qt of Neil Hodgson's Scintilla C++ editor class
Name: qscintilla2
Version: 2.2
Release: alt1.M41.1
License: GPL
Group: Development/KDE and QT
Source: qscintilla-%version.tar
Patch0: qscintilla-%version-alt-allinone.patch

Packager: Gennady Kovalev <gik@altlinux.ru>
URL: http://www.riverbankcomputing.co.uk/software/qscintilla/

BuildRequires: libqt3-devel libqt4-devel gcc-c++ python python-module-PyQt4-devel python-module-qt-devel
BuildRequires: python-module-sip-devel

%description
Qscintilla is a free source code editing component. It comes with complete
source code and a license that permits use in any free project or commercial
product. As well as features found in standard text editing components,
Scintilla includes features especially useful when editing and debugging
source code. These include support for syntax styling, error indicators, code
completion and call tips. The selection margin can contain markers like those
used in debuggers to indicate breakpoints and the current line. Styling
choices are more open than with many editors, allowing the use of proportional
fonts, bold and italics, multiple foreground and background colours and
multiple fonts.


%package -n lib%name-qt3
Summary: QScintilla is a port to Qt of Neil Hodgson's Scintilla C++ editor class. e
Group: Development/KDE and QT
Conflicts: libqscintilla

%description -n lib%name-qt3
Qscintilla is a free source code editing component. It comes with complete
source code and a license that permits use in any free project or commercial
product. As well as features found in standard text editing components,
Scintilla includes features especially useful when editing and debugging
source code. These include support for syntax styling, error indicators, code
completion and call tips. The selection margin can contain markers like those
used in debuggers to indicate breakpoints and the current line. Styling
choices are more open than with many editors, allowing the use of proportional
fonts, bold and italics, multiple foreground and background colours and
multiple fonts.


%package -n lib%name-qt4
Summary: QScintilla is a port to Qt of Neil Hodgson's Scintilla C++ editor class. e
Group: Development/KDE and QT

%description -n lib%name-qt4
Qscintilla is a free source code editing component. It comes with complete
source code and a license that permits use in any free project or commercial
product. As well as features found in standard text editing components,
Scintilla includes features especially useful when editing and debugging
source code. These include support for syntax styling, error indicators, code
completion and call tips. The selection margin can contain markers like those
used in debuggers to indicate breakpoints and the current line. Styling
choices are more open than with many editors, allowing the use of proportional
fonts, bold and italics, multiple foreground and background colours and
multiple fonts.


%package -n lib%name-qt3-devel
Requires: lib%name-qt3 = %version-%release
Summary: Header files for %name
Group: Development/KDE and QT

%description -n lib%name-qt3-devel
Header files for %name


%package -n lib%name-qt4-devel
Requires: lib%name-qt4 = %version-%release
Summary: Header files for %name
Group: Development/KDE and QT

%description -n lib%name-qt4-devel
Header files for %name


%package -n lib%name-python-devel
Requires: lib%name-qt3 = %version-%release
Summary: Python bindings for %name
Group: Development/KDE and QT

%description -n lib%name-python-devel
Sim files for %name


%package -n lib%name-qt3-python
Requires: lib%name-qt3 = %version-%release
Summary: Python bindings for %name
Group: Development/KDE and QT

%description -n lib%name-qt3-python
Python bindings for %name


%package -n lib%name-qt4-python
Requires: lib%name-qt4 = %version-%release
Summary: Python bindings for %name
Group: Development/KDE and QT

%description -n lib%name-qt4-python
Python bindings for %name


%package -n lib%name-qt3-designer
Requires: lib%name = %version-%release
Summary: QScintilla designer plugin
Group: Development/KDE and QT

%description -n lib%name-qt3-designer
QScintillla designer plugin.


%package -n lib%name-qt4-designer
Requires: lib%name = %version-%release
Summary: QScintilla designer plugin
Group: Development/KDE and QT

%description -n lib%name-qt4-designer
QScintillla designer plugin.


%package -n lib%name-doc
Requires: lib%name = %version-%release
Summary: Documentation for %name
Group: Development/KDE and QT

%description -n lib%name-doc
Documentation for %name


%prep
%setup -n qscintilla-%version
%patch -p1

%build
# Qt3
cd Qt3
%qt3dir/bin/qmake qscintilla.pro
%make
cd ..

# Designer for Qt3
cd designer-Qt3
%qt3dir/bin/qmake designer.pro
%make
cd ..

# Python bindings
cd Python
python configure.py -p 3 -n ../Qt3 -o ../Qt3
%make
#mv qsci.so qsci-qt3.so
mv QScintilla2.api QScintilla2-Qt3.api
cd ..

# Qt4
cd Qt4
%qt4dir/bin/qmake qscintilla.pro
%make
cd ..

# Designer for Qt4
cd designer-Qt4;
%qt4dir/bin/qmake designer.pro
%make
cd ..

# Python bindings for PyQt4
cd Python
python configure.py -p 4 -n ../Qt4 -o ../Qt4
%make
#mv qsci.so qsci-qt4.so
mv QScintilla2.api QScintilla2-Qt4.api
cd ..

%install
mkdir -p %_libdir
mkdir -p %buildroot%qt3dir/{include/Qsci,lib,translations,plugins/designer}
mkdir -p %buildroot%qt4dir/{include/Qsci,lib,translations,plugins/designer}
mkdir -p %buildroot%_datadir/doc/lib%name-%version/Scintilla
mkdir -p %buildroot%_datadir/doc/lib%name-%version/html-Qt3
mkdir -p %buildroot%_datadir/doc/lib%name-%version/html-Qt4
mkdir -p %buildroot%_datadir/sip/qsci
mkdir -p %buildroot%_libdir/python%__python_version/site-packages/PyQt4
mkdir -p %buildroot%_datadir/qt3/qsci/api/python
mkdir -p %buildroot%_datadir/qt4/qsci/api/python

# Qt3 library
install Qt3/lib%name.so.*.*.* %buildroot%qt3dir/lib
install Qt3/*.qm %buildroot%qt3dir/translations
cd %buildroot%qt3dir/lib
ln -s lib%name.so.*.*.* `ls lib%name.so.*.*.* | sed s/\.[0-9]$//`
ln -s lib%name.so.*.*.* `ls lib%name.so.*.*.* | sed s/\.[0-9]\.[0-9]$//`
ln -s lib%name.so.*.*.* `ls lib%name.so.*.*.* | sed s/\.[0-9]\.[0-9]\.[0-9]$//`
cd -

# Qt4 library
install Qt4/lib%name.so.*.*.* %buildroot%_libdir
install Qt4/*.qm %buildroot%qt4dir/translations
cd %buildroot%_libdir
ln -s lib%name.so.*.*.* `ls lib%name.so.*.*.* | sed s/\.[0-9]$//`
ln -s lib%name.so.*.*.* `ls lib%name.so.*.*.* | sed s/\.[0-9]\.[0-9]$//`
ln -s lib%name.so.*.*.* `ls lib%name.so.*.*.* | sed s/\.[0-9]\.[0-9]\.[0-9]$//`
cd -
cd %buildroot%qt4dir/lib
for libname in ../../lib%name.so*; do
	ln -s $libname ./
done
cd -

# Qt3 designer
install designer-Qt3/libqscintillaplugin.so %buildroot%qt3dir/plugins/designer

# Qt4 designer
install designer-Qt4/libqscintillaplugin.so %buildroot%qt4dir/plugins/designer

# Qt3 headers
install Qt3/*.h %buildroot%qt3dir/include
install Qt3/Qsci/*.h %buildroot%qt3dir/include/Qsci

# Qt4 headers
install Qt4/*.h %buildroot%qt4dir/include
install Qt4/Qsci/*.h %buildroot%qt4dir/include/Qsci

# Sip files
install Python/sip/*.sip %buildroot%_datadir/sip/qsci

# Qt3 python bindings
install Python/qsci.so %buildroot%_libdir/python%__python_version/site-packages/qsci.so
install Python/QScintilla2-Qt3.api %buildroot%_datadir/qt3/qsci/api/python

# Qt4 python bindings
install Python/Qsci.so %buildroot%_libdir/python%__python_version/site-packages/PyQt4/Qsci.so
install Python/QScintilla2-Qt4.api %buildroot%_datadir/qt4/qsci/api/python

# docs
install doc/Scintilla/* %buildroot%_datadir/doc/lib%name-%version/Scintilla
install doc/html-Qt3/* %buildroot%_datadir/doc/lib%name-%version/html-Qt3
install doc/html-Qt4/* %buildroot%_datadir/doc/lib%name-%version/html-Qt4


%post -n lib%name-qt3
%post_ldconfig

%post -n lib%name-qt4
%post_ldconfig

%postun -n lib%name-qt4
%postun_ldconfig

%postun -n lib%name-qt3
%postun_ldconfig


%files -n lib%name-qt3
%qt3dir/lib/lib%name.so.*
%qt3dir/translations/*

%files -n lib%name-qt4
%_libdir/lib%name.so.*
%qt4dir/lib/*
%qt4dir/translations/*

%files -n lib%name-python-devel
%_datadir/sip/qsci/*

%files -n lib%name-qt3-python
%_libdir/python%__python_version/site-packages/qsci.so
%_datadir/qt3/qsci/api/python/QScintilla2-Qt3.api

%files -n lib%name-qt4-python
%_libdir/python%__python_version/site-packages/PyQt4/Qsci.so
%_datadir/qt4/qsci/api/python/QScintilla2-Qt4.api

%files -n lib%name-qt3-devel
%dir %qt3dir/include/Qsci
%qt3dir/include/*.h
%qt3dir/include/Qsci/*.h
%qt3dir/lib/lib%name.so

%files -n lib%name-qt4-devel
%dir %qt4dir/include/Qsci
%qt4dir/include/*.h
%qt4dir/include/Qsci/*.h
%_libdir/lib%name.so

%files -n lib%name-qt3-designer
%qt3dir/plugins/designer/*

%files -n lib%name-qt4-designer
%qt4dir/plugins/designer/*

%files -n lib%name-doc
%dir %_datadir/doc/lib%name-%version/Scintilla
%_datadir/doc/lib%name-%version/Scintilla/*
%dir %_datadir/doc/lib%name-%version/html-Qt3
%_datadir/doc/lib%name-%version/html-Qt3/*
%dir %_datadir/doc/lib%name-%version/html-Qt4
%_datadir/doc/lib%name-%version/html-Qt4/*


%changelog
* Thu Sep 25 2008 Michael Shigorin <mike@altlinux.org> 2.2-alt1.M41.1
- built for M41 (on glebus' request)

* Fri May 02 2008 Gennady Kovalev <gik@altlinux.ru> 2.2-alt2
- Version 2.2

* Fri Jan 04 2008 Gennady Kovalev <gik@altlinux.ru> 2-alt1.20080103
- Version 2, 20080103 snapshot
 + fixed python dependency
 + fixed RPATH bug during build

* Wed Jan 02 2008 Gennady Kovalev <gik@altlinux.ru> 2-alt2.20071223
- Fixed symlinks in lib

* Mon Dec 31 2007 Gennady Kovalev <gik@altlinux.ru> 2-alt1.20071223
- Version 2, 20071223 snapshot

* Wed Jan 11 2006 Ivan Fedorov <ns@altlinux.ru> 1.6-alt1
- 1.6

* Sat Mar 12 2005 Ivan Fedorov <ns@altlinux.ru> 1.5.1-alt1
- 1.5.1

* Mon Feb 21 2005 Ivan Fedorov <ns@altlinux.ru> 1.5-alt1
- 1.5

* Tue Jan 18 2005 ALT QA Team Robot <qa-robot@altlinux.org> 1.4-alt1.1
- Rebuilt with libstdc++.so.6.

* Tue Sep 21 2004 Eugene V. Horohorin <genix@altlinux.org> 1.4-alt1
- new release
- spec clean up
- Rex Dieter's patch for qt-designer plugin: don't require an already installed
  qscintilla-devel

* Tue May 18 2004 Serge V. Sergeev <ssv@altlinux.ru> 1.3-alt1
- new release
- appropriate spec changes

* Thu Dec 11 2003 Serge V. Sergeev <ssv@altlinux.ru> 1.2-alt1
- new release

* Tue Jul 08 2003 Serge Sergeev <ssv@altlinux.ru> 1.1-alt1
- new release
- add define subver
- some minor changes

* Thu Apr 10 2003 Serge Sergeev <ssv@altlinux.ru> 0.4-alt0.1
- New release from snapshot

* Mon Dec 23 2002 Serge Sergeev <ssv@altlinux.ru> 0.3-alt1.2
- fixed install section

* Fri Dec 20 2002 Serge Sergeev <ssv@altlinux.ru> 0.3-alt1.1
- build from snapshot (corrects encodings)

* Tue Dec 17 2002 Serge Sergeev <ssv@altlinux.ru> 0.3-alt1
- Initial release

